% merges 2 datasets
% based on mergeYcsv.m, which was designed for decodeme and 23and me
%
% NITE: input sheet must be saved according to some specified format (usu csv)
%       the first column must be the rs number and the second the position
%       First line= haplogroup
%       Second line= observation name
%       Third line= whatever but no data yet
%       We assume data starts from line 4
%       Do not put trailing empty cells neither at the far right of the data
%       nor at the bottom
%
% Input:
%       number obs of each dataset 
%       the filename of each of the two input csv sheet
%       output filename (csv format)
%	fileformat: how the data is organized
%		    1 decodeme xls: 4 columns of info, then data
%		    2 23andme v1 Ann Turner: 2 col info
%		    3 23andme v2 direct download delimiter = space
%       number of columns before data start for each dataset, either 4 or 2 
%       (if =4 pay attention to order. We need the orientation)
%
%	requires m files:
%		 readandreverseallele.m = reads whole matrix and changes allele with - orientation
%		 reverseallele.m        = changes allele with - orientation
%		 settonull.m	        = sets null to the same value

%%%%%%%%%%%%%%%%%%%%%%%%%%
%INPUT VALUES
nobs1=1;   %number of people in dataset 1
nobs2=1;    %number of people in dataset 2
	    % hapmapCEU = 90 hapmapCHB=45 hapmapJPT=45 hapmapYRI=90
file1='cacioYdecodeme.csv';
file2='cacioY23andme.txt';
fileoutput='cacioYmerged.csv';
format1=1;% format of file1
format2=3;% format of file2
%%%%%%%%%%%%%%%%%%%%%%%%%%%
nobs=nobs1+nobs2;

disp(' ')

firstlineoutfile= strcat('Haplogroup',',');
secondlineoutfile=strcat('ID',',');
for thisfile=1:2
    if (thisfile==1)
       thisfilename=file1;
       thisnumobs=nobs1;
       thisformat=format1;
    else
       thisfilename=file2;
       thisnumobs=nobs2;
       thisformat=format2;
    end
    disp(['Reading ' thisfilename])
    %take care of the first three lines
    fi=fopen(thisfilename);
    mystringobs='%s';
    for i=1:thisnumobs-1
        mystringobs=strcat(mystringobs,' %s');
    end;   
    if (thisformat == 1)	% 4 info columns
        thiscolumninfo=4;
        mystring='%s %s %s %s';
        mystring=strcat(mystring,mystringobs);
    	%take care of header lines
    	cacca=textscan(fi,mystring, 'delimiter' , ',');
    	fclose(fi);
    	for i=thiscolumninfo+1:thisnumobs+thiscolumninfo
            firstlineoutfile= strcat(firstlineoutfile, ',',cacca{i}(1,1));
            secondlineoutfile=strcat(secondlineoutfile, ',',cacca{i}(2,1));
    	end
    	clear cacca
    	fi=fopen(thisfilename);
        mystring='%s %s %n %s';
        mystring=strcat(mystring,mystringobs);
        resi=textscan(fi,mystring, 'delimiter',',','headerLines',3);
        nrsi=size(resi{1},1);
	fclose(fi);
	allelei=readandreverseallele(resi,nrsi,thisnumobs);
    end

    if (thisformat == 2)	% 2 info columns
        thiscolumninfo = 2;
        mystring='%s %s';
        mystring=strcat(mystring,mystringobs);
    	cacca=textscan(fi,mystring, 'delimiter' , ',');
    	fclose(fi);
    	for i=thiscolumninfo+1:thisnumobs+thiscolumninfo
            firstlineoutfile= strcat(firstlineoutfile, ',',cacca{i}(1,1));
            secondlineoutfile=strcat(secondlineoutfile, ',',cacca{i}(2,1));
    	end
    	clear cacca
    	fi=fopen(thisfilename);
        mystring='%s %n';
        mystring=strcat(mystring,mystringobs);
        resi=textscan(fi,mystring, 'delimiter',',','headerLines',3);
        nrsi=size(resi{1},1);
	fclose(fi);
    	for i=1:thisnumobs;
            allelei(1:nrsi,2*(i-1)+1:2*(i-1)+2) = char(resi{2+i}); 
    	end
    end

     if (thisformat == 3)
        thiscolumninfo = 3;
        mystring='%s %s %s';
        mystring=strcat(mystring,mystringobs);
    	cacca=textscan(fi,mystring);
    	fclose(fi);
    	for i=thiscolumninfo+1:thisnumobs+thiscolumninfo
            firstlineoutfile= strcat(firstlineoutfile, ',',cacca{i}(1,1));
            secondlineoutfile=strcat(secondlineoutfile, ',',cacca{i}(2,1));
    	end
    	clear cacca
    	fi=fopen(thisfilename);
        mystring='%s %s %n';
        mystring=strcat(mystring,mystringobs);
        resi=textscan(fi,mystring,'headerLines',3);
        nrsi=size(resi{1},1);
	fclose(fi);
	%need to double AA etc; null is already --
	allelei=readanddouble(resi,thisnumobs,nrsi);
    end
    
    if (thisfile == 1 )
       res1=resi;
       nrs1=nrsi;
       allele1=allelei;
    end
    if (thisfile == 2)
       res2=resi;
       nrs2=nrsi;
       allele2=allelei;
    end

    disp(['Read ' thisfilename])
    clear resi nrsi allelei

end
disp([file1 ' contains ' num2str(nobs1) ' observations and ' num2str(nrs1) ' rs lines'])
disp([file2 ' contains ' num2str(nobs2) ' observations and ' num2str(nrs2) ' rs lines'])
disp(' ')

for thisfile=1:2
    disp(['Eliminating repeat position from database ' num2str(thisfile)])
    if thisfile==1
       thisres=res1;
       nrsi=nrs1;
       thisformat=format1;
       allelei=allele1;
       clear allele1
    else
       thisres=res2;
       nrsi=nrs2;
       thisformat=format2;
       allelei=allele2;
       clear allele2
    end
    thisrsnumber=thisres{1};
    if (thisformat==1)
       locrstem=thisres{3};
    end
    if (thisformat==2)
       locrstem=thisres{2};
    end
    if (thisformat==3)
       locrstem=thisres{3};
    end
    [locrs_s_tem,ix]=sort(locrstem(:,1));
    allele_s_tem=allelei(ix,:);
    rsnumber_s_temp=thisrsnumber(ix);
    for i=2:nrsi,
    	isasnext(i-1,1)=( locrs_s_tem(i,1)==locrs_s_tem(i-1,1) );
    end;
    isasnext(nrsi,1)=false;       %there's nothing after last obs, so false
    findisnotasnext=find(~isasnext); %this picks the second when repeat
    nnoncommon=size(findisnotasnext,1);
    disp(['There are ' num2str(nrsi-nnoncommon) ' duplicates in dataset ' num2str(thisfile)])
    allele_new=allele_s_tem(findisnotasnext,:);
    rsnumber_new=rsnumber_s_temp(findisnotasnext,1);
    locrs_new=locrs_s_tem(findisnotasnext,1);
    if thisfile==1
       nrs1_norepeat=nnoncommon;
       rsnumber(1:nrs1_norepeat,1)=rsnumber_new;
       locrs(1:nrs1_norepeat,1)=locrs_new;
       locrs(1:nrs1_norepeat,2)=1; %dataset number
       allele1=allele_new;
    else
       nrs2_norepeat=nnoncommon;
       ntotrs=nrs1_norepeat+nrs2_norepeat;
       rsnumber(nrs1_norepeat+1:ntotrs,1)=rsnumber_new;
       locrs(nrs1_norepeat+1:ntotrs,1)=locrs_new;
       locrs(nrs1_norepeat+1:ntotrs,2)=2; %dataset number
       allele2=allele_new;
    end
    clear isasnext locrs_s_tem allele_s_tem rsnumber_s_temp rsnumber_new locrs_new
    clear nnoncommon thisres thisrsnumber
end
disp([file1 ' contains ' num2str(nobs1) ' observations and ' num2str(nrs1_norepeat) ...
	    ' nonduplicate rs lines'])
disp([file2 ' contains ' num2str(nobs2) ' observations and ' num2str(nrs2_norepeat) ...
	    ' nonduplicate rs lines'])
disp(' ')
disp('Creating big stacked matrix with all info to be sorted')

%allele values as big matrix
%fill '-' when the obs doesn't belong to the dataset
allele=allele1;
for i=1:nrs1_norepeat,
    for j=2*nobs1+1:2*nobs
    	allele(i,j)='-';
    end;
end;
for i=nrs1_norepeat+1:ntotrs,
    for j=1:nobs1*2
    	allele(i,j)='-';
    end;
end;
allele(nrs1_norepeat+1:ntotrs,2*nobs1+1:2*nobs)=allele2;

% set nulls to same value
allele=settonull(allele,'-');

disp('sorting stuff by position')
[locrs_si,ix]=sort(locrs(:,1));
locrs_s=locrs(ix,:);
allele_s=allele(ix,:);
rsnumber_s=rsnumber(ix);

%common rs are those with the same position
for i=2:ntotrs,
    isasnext(i-1,1)=( locrs_s(i,1)==locrs_s(i-1,1) );
end;
%there's nothing after last obs, so false
isasnext(ntotrs,1)=false;
findasnext=find(isasnext);
ncommon=size(findasnext,1);
disp(['There are ' num2str(ncommon) ' common rs'])
if isempty(findasnext)
   disp('No common rs?')
end;
nrsmerged=ntotrs-ncommon;

%create new matrix allele_m with filler '9'
for i=1:nrsmerged,
    for j=1:2*nobs,
    	allele_m(i,j)='9';
    end;
end;
locrs_m=zeros(nrsmerged,2);

disp('Merging')
%indicator telling us whether we need to input line i or not
hasbeenmerged=false; %first line has not been input
k=1; %index of merged matrix
for i=1:ntotrs
    if hasbeenmerged	%don't do anything. next one will have to be merged
       hasbeenmerged=false;
    else  %must add a new rs
       if ~isasnext(i,1)  %not as next, put in whole line as is
           rsnumber_m(k,1)=rsnumber_s(i);
           locrs_m(k,:)=locrs_s(i,:);
           allele_m(k,:)=allele_s(i,:);
       else               %must merge with next
           rsnumber_m(k,1)=rsnumber_s(i,1);
	       locrs_m(k,:)=locrs_s(i,:);
	       whichdataset=locrs_s(i,2);
           if ( whichdataset== 1 ), %put in whichever col is appropriate
    	      allele_m(k,1:2*nobs1)=allele_s(i,1:2*nobs1);
	          allele_m(k,2*nobs1+1:2*nobs)=allele_s(i+1,2*nobs1+1:2*nobs);
    	   else
	          allele_m(k,1:2*nobs1)=allele_s(i+1,1:2*nobs1);
	          allele_m(k,2*nobs1+1:2*nobs)=allele_s(i,2*nobs1+1:2*nobs);
	       end
	       hasbeenmerged=true;
       end
       k=k+1;
    end
end

disp('Sort merged file')
clear ix;
[locrs_s2,ix]=sort(locrs_m(:,1));
locrs_m_s=locrs_m(ix,:);
allele_m_s=allele_m(ix,:);
rsnumber_m_s=rsnumber_m(ix);

disp(['Writing sorted output to file ' fileoutput])
fi=fopen(fileoutput,'w');
fprintf(fi,'%s\n',char(firstlineoutfile));
fprintf(fi,'%s\n',char(secondlineoutfile));
fprintf(fi,'%s\n',' ');
for i=1:nrsmerged
    mystring=rsnumber_m_s(i);
    mystring=strcat(mystring,',',num2str(locrs_m_s(i,1)));
    for j=1:nobs,
    	mystring=strcat(mystring,',',allele_m_s(i,2*(j-1)+1:2*(j-1)+2));
    end;
    towrite=char(mystring);
    fprintf(fi,'%s\n',towrite);   
end
fclose(fi);
disp('Done - saved file')
disp([ fileoutput ' contains ' num2str(nobs) ' observations and ' num2str(nrsmerged) ' rs'])
